<?php
/*
    .
Outputs[RELE1,RELE2,OUT1,OUT2,OUT3,OUT4,OUT5]
3 - OUT2   
*/

//     .
$temp_off = 5.5;
$temp_on = 1;
$period = 3;	//       .   .

require_once("ab-cms/class/main_class.php");
$ab = new cms_lib();

$keys_id = $ab->get_id("keys");
$ccu825_id = $ab->get_id("ccu825_events");
$ccu825_temp_id = $ab->get_id("ccu825_temp");
$keys_journal_id = $ab->get_id("keys_journal");

#  HTTP Basic     JSON.
function http_auth_get($url,$username,$password){
	$cred = sprintf('Authorization: Basic %s',
	base64_encode("$username:$password"));
	$opts = array('http'=>array('method'=>'GET','header'=>$cred));
	$ctx = stream_context_create($opts);
	$handle = fopen ( $url, 'r', false,$ctx);

	return stream_get_contents($handle);
}

# /  .
function heat($heat_pio){
	#        ccu proxy.
	$jsonHost = "localhost:8080";
	$jsonUser = "admin";
	$jsonPass = "XXXXXXX";

	$json = http_auth_get('http://'.$jsonHost.'/data.cgx?cmd={"Command":"SetOutputState","Number":4,"State":'.$heat_pio.'}',$jsonUser,$jsonPass);
	$obj = json_decode($json, TRUE);
	
	if( !empty($obj) ) {
		#    2  + 5  .
		$ccuOutputs = $obj['Outputs'];
		$ccuPower = $obj['Power'];
		
		$out3 = $ccuOutputs[3];
		
		//echo $out3; echo "\n";
		//echo $ccuPower; echo "\n";
		
		if( $out3 == $heat_pio ){
			return $heat_pio;
		} else {
			return -1;
		}
	}
}

$loop = 1;
$count = 0;
#    ccu825,   .
while ( $loop == 1)
{
	# ,    heat_auto=1.   heat_auto,   .
	#   heat_auto
	$heat_auto = $ab->mod_read($keys_id, "#key_pio#", "", 1, "key_label='heat_auto'");
	#     ON/OFF
	$heat_mode = $ab->mod_read($keys_id, "#key_pio#", "", 1, "key_label='heat'");
	
	if($heat_auto == 1){
		$time = date("d.m.y H:i:s");
		#   .
		$request = "http://192.168.0.14/sec/?pt=5&cmd=get";
		$temp =  file_get_contents($request);
			
		if ( !empty($temp) )
		{
			//   temp:   DS18B
			$temp = preg_replace('/^temp:/', '', $temp);
		
			if( empty($temp_prev) ) $temp_prev = $temp;	//  .
		
			$delta_temp = $temp - $temp_prev;
			if( (0 <= $delta_temp) && ($delta_temp < 0.01 ) )
				$count++;	//    .
			else
				$count = 0;
		
			if($temp > $temp_off || $count >= $period ){
				if( $heat_mode == 1 ){
					// .
					echo " Heat turn OFF.";
					if(heat(0) == -1) echo "Heat turn off ERROR.\n"; // .
				}
			} elseif( $temp < $temp_on ) {
				if( $heat_mode == 0 ){
					// .
					echo " Heat turn ON.";
					if(heat(1) == -1) echo "Heat turn on ERROR.\n"; // .
				}
			}
			$temp_prev = $temp;
			echo " $time: temp: $temp delta: $delta_temp count: $count\n"; //debug
		} else {
			echo "Error get temp.\n";
		}
	} elseif($heat_mode == 1) {
		// .
		echo " Heat turn OFF.";
		if(heat(0) == -1) echo "Heat turn off ERROR.\n"; // .	
	}
	
	#   
	sleep(600);
}

?>